import java.awt.*;
import java.io.*;

class ListLink 
{
	class Node {
		Module inM,outM;
		int inIO;
		Node next;
	}

	Node root = null;

	public void add(Module outM,Module inM,int inIO) {
		Node N = new Node();
		N.inM = inM;
		N.outM = outM;
		N.inIO = inIO;
		N.next = root;
		root = N;
	}

	public void remove(Module M,int IO) {
		Node O=null,N = root;
		while (N!=null) {
			if (((N.inM==M) && (N.inIO==IO)) || ((N.outM==M) && (IO==-1))) {
				if (O==null) root=N.next;
				else O.next=N.next;
			} else {
				O = N;
			}
			N = N.next;
		}
	}

	public boolean linkTo(Module M,int IO) {
		Node N = root;
		while (N!=null) {
			if ((N.inM==M) && (N.inIO==IO)) return true;
			if ((N.outM==M) && (IO==-1)) return true;
			N = N.next;
		}
		return false;
	}

	public Module getLink(Module M,int IO) {
		Node N = root;
		while (N!=null) {
			if ((N.inM==M) && (N.inIO==IO)) return N.outM;
			if ((N.outM==M) && (IO==-1)) return N.inM;
			N = N.next;
		}
		return null;
	}

	public void draw(Graphics g) {
		Node N = root;
		while (N!=null) {
			Pt A,B;
			A = N.inM.getIO(N.inIO);
			B = N.outM.getIO(-1);
			g.setColor(Color.BLACK);
			g.drawLine(A.x,A.y,B.x,B.y);
			N = N.next;
		}
	}

	public void load(BufferedReader F) throws Exception {
		String[] S = F.readLine().split(",");
		add(Const.proj.mods.get(Integer.parseInt(S[0])),
			Const.proj.mods.get(Integer.parseInt(S[1])),
			Integer.parseInt(S[2]));
	}

	public void save(BufferedWriter F) throws Exception {
		Node N = root;
		while (N!=null) {
			F.write("LINK:\n");
			F.write(N.outM.n+","+N.inM.n+","+N.inIO+"\n");
			N = N.next;
		}
	}
}
